"use strict";
angular.module('starter.controlFeedback', ['sync-service'])

.controller('FeedbackController', function($rootScope,$scope,$state,$ionicPopup, registerService,syncableDatabase) {

	$scope.name='';
	$scope.email='';
	$scope.feedback='';

	/* only works if don't go direct to page on load during debuging, as the registerService load is async */
	if( registerService.registered() ){
      var reg=registerService.get();
      $scope.name=reg.name;
      $scope.email=reg.email;
  	}

	if( typeof navigator.appInfo != 'undefined' ){
		$scope.version = navigator.appInfo.version;
		$scope.build = navigator.appInfo.build;
	}else{
		$scope.version = 'dev';
		$scope.build = navigator.userAgent;
	}

  	$scope.sendFeedback=function( evt,f ){
  		var v = '<br><br>Version :'+$scope.version+' build :'+$scope.build+' on '+ionic.Platform.platform();

  		syncableDatabase.db().transaction(function(tx) {
  			tx.executeSql("insert into feedback2 (date,name,email,feedback) values (?,?,?,?)",
	            [new Date().getTime(),f.cname.$viewValue,f.cemail.$viewValue,f.cfeedback.$viewValue+v],
	            function(tx,r){
	            	syncableDatabase.sync();
					$ionicPopup.alert({
						title: 'Feedback sent',
						template: 'Thanks for your feedback.',
						cssClass: 'feedback ok review',
						okType	: 'button-balanced'
					});
					$state.go('app.home');
		        },
	            function(tx,e){
	            	console.error('failed to save feedback '+e.message);
	            	$ionicPopup.alert({
						title: 'Error sending feedback' ,
						template: 'Please contact us via the app. store instead.',
						cssClass: 'feedback error review',
						okType	: 'button-balanced'
					});
	            }
	        );
  		}
		),
    function(e){ console.error('failed to save feedback');console.dir(e); }
    }

});