"use strict";
angular.module('starter.controllers', ['sync-service','email-ask.service',"email-service",'register-service','profile-dialog'])

.controller('AppCtrl', function($rootScope,$scope,$state,$ionicPopover,$ionicPopup,$timeout,$ionicLoading,$ionicPlatform, geoService,registerService,profileDialog,syncableDatabase) {

  $scope.log='Nothing';
  $scope.logR='Nothing';

  $scope.shouldHideTabs = function () {
     switch ($state.current.name) {
        case 'app.home':
          return "tabs-item-hide";
        case 'app.menu':
          return "tabs-item-hide";
        case 'app.more':
          return "tabs-item-hide";
        case 'app.pdf':
          return "tabs-item-hide";
        default:
          return '';
    }
  }

  var _preferenceKey="has_seen_terms_and_conditions";
  syncableDatabase.db().transaction(function(tx){
    $scope.log='select v from p';
    tx.executeSql('select value from preferences where name=?',[_preferenceKey], function (tx,results){
      $scope.log='select v from p tx';
      $scope.log='select v from p tx '+results.rows.length;
      if( results.rows.length == 0 ){
        if(navigator.splashscreen){
          navigator.splashscreen.hide();
        }
        tx.executeSql('insert into preferences (value,name) values (?,?)',['true',_preferenceKey]);
        var confirmPopup = $ionicPopup.alert({
          title:'Terms and conditions',
          templateUrl:'templates/terms.html',
          okType: 'button-balanced'
        });
      }
    });
  });

  $scope.showMainMoreMenu=false;

  $scope.logR='Nothing';
  $scope.registered=registerService.registered();
  $scope.logR='init '+$scope.registered;
  $scope.$on('event:registerChanged', function(e, rejection) {
    $scope.logR='registerChanged ';
    $scope.registered=registerService.registered();
    $scope.logR='registerChanged '+$scope.registered;
    if(navigator.splashscreen){
      navigator.splashscreen.hide();
    }
  });

  /*
  Seems iOS has asubtle timing bug that gives the impression of
  forgetting the user and/or an exception that leaves the spash up.
  So nudge the check again after removing the splash
  */
  $timeout(function() {
    $scope.logR='timout ';
    if(navigator.splashscreen){
      navigator.splashscreen.hide();
    }
    registerService._updateRegistered();
    $scope.logR='_update done ';
  },250);

  $ionicLoading.show();

  $scope.regionPopoverEnabled = false;
  $scope.currentRegion={};
  $scope.regions = geoService.getRegions();

  $scope.setCurrentRegion = function(r){
    geoService.setCurrentRegion(r);
    $scope.currentRegion = r;
    $scope.regionPopover.hide();
  }

  $ionicPopover.fromTemplateUrl('templates/popover-region.html',{
      scope : $scope
  })
  .then(function(popover){
    $scope.regionPopover = popover;

    $ionicPlatform.ready(function() {

      geoService.get()
      .then(function(position){
        $scope.currentRegion = geoService.getRegionForPosition( position );
        geoService.setCurrentRegion( $scope.currentRegion );
        $scope.regionPopoverEnabled = true;
        $ionicLoading.hide();
      })
      .catch(function(error){
        if( console&&console.error ) console.error('AppCtrl : geoService failure : ' + error);

        if( error.message.toLowerCase().indexOf('timeout') >-1  || error.code == 3 ){
          console.log('2');
          geoService.get(
            {
              maximumAge: 30*60*1000,
              timeout: 60*1000
            }
          ).then(function(p){
  //console.log('AppCtrl background position back');
          }).catch(function(p){
  console.log('AppCtrl background position failed');
          });
        }

        $scope.currentRegion = $scope.regions[0];
        geoService.setCurrentRegion( $scope.currentRegion );
        $scope.regionPopoverEnabled = true;
        $ionicLoading.hide();
      });

  });

  })
  .catch(function(error){
    $ionicLoading.hide();
console.log('appctrl 55');
    alert(error);
  });

  $ionicPopover.fromTemplateUrl('templates/tabs-more.html', {
    scope: $scope
  }).then(function(popover) {
    $scope.morePopover = popover;
  });

  $scope.toggleMainMenuMore = function(){
    $scope.showMainMoreMenu=!$scope.showMainMoreMenu
  }

  $scope.showRegisterIfRequiredRefer = function(evt){
    if(! showRegisterIfRequired(evt) ){
      $state.go('app.refer').then(function(){
          $rootScope.$broadcast('event:clearRefer');
      });
    }
  }
  $scope.showRegisterIfRequiredSummary = function(evt){
    if(! showRegisterIfRequired(evt) ){
      $state.go('app.summary');
    }
  }

  $scope.showAndClearCalc=function(evt){
      $state.go('app.calc').then(function(){
          $rootScope.$broadcast('event:clearCalc');
      });
  }
  $scope.showAndClearRefer=function(evt){
    if(! showRegisterIfRequired(evt) ){
      $state.go('app.refer').then(function(){
          $rootScope.$broadcast('event:clearRefer');
      });
    }
  }

  $scope.showTabMore = function(evt){
    $scope.morePopover.show(evt);
  }
  $scope.hideTabMore = function(){
    $scope.morePopover.hide();
  }

  $scope.showMainMenuLocationFull = function(evt){
    if( $scope.regionPopoverEnabled ){
      $scope.regionPopover.show(evt);
    }
  }

  function showRegisterIfRequired (evt){
    if( !$scope.registered ){

      $ionicPopup.show({
        template: 'You must be registered with a valid address to use this.',
        buttons:[
          {
            text:'register now',
            type: 'button-balanced',
            scope:$scope,
            onTap:function(e){$scope.showProfile(e);}
          }
        ]
      });

      return true;
    }
    return false;
  }
  $scope.showProfile=function(evt){
    $timeout(function() {
      profileDialog(evt);
    }, 350);
  }

  $scope.$on('$destroy', function() {
    $scope.regionPopover.remove();
    $scope.morePopover.remove();
  });
})

.controller('HomeCtrl', function($scope) {



})

.controller('LinksCtrl', function($scope) {


  $scope.windowOpen = function windowOpen(url){
    var ref = window.open(url, '_system', 'location=yes');
  }

  $scope.links = [
    { title: 'Think kidneys', url: 'https://www.thinkkidneys.nhs.uk/'},
    { title: 'NICE AKI guidelines', url: 'https://www.nice.org.uk/guidance/cg169'},
    { title: 'NICE fluid guidelines', url: 'http://www.nice.org.uk/guidance/cg174' },
    { title: 'RCP AKI ToolKit', url: 'https://www.rcplondon.ac.uk/file/1523/download?token=-gK977Uh' },
    { title: 'AQ AKI Standards', url: 'http://www.advancingqualitynw.nhs.uk/condition/acute-kidney-injury/' },
    { title: 'AKI Discharge CQUIN', url: 'https://www.england.nhs.uk/statistics/wp-content/uploads/sites/2/2014/07/CQUIN-Guidance-2015-16-PDF-641KB.pdf' },
  ];
})

.controller('SummaryCtrl', function($scope) {
  $scope.advice = [
    {title:'Document AKI and stage in notes'},
    {title:'Inform senior medical staff'},
    {title:'Document dipstick and USS results'},
    {title:'Regularly assess volume state'},
    {title:'Review fluid balance regularly'},
    {title:'Check bloods daily'},
    {title:'Treat the underlying cause of AKI'}
  ];
})

.controller('UnitsCtrl', function($scope,$ionicModal,$ionicPopup, registerService,syncableDatabase) {
  $scope.$on('$ionicView.enter', function() {
    if( registerService.registered() ){
      var reg=registerService.get();
      $scope.name=reg.name!='undefined'?reg.name:'';
      $scope.email=reg.email;
    }
  });

  $ionicModal.fromTemplateUrl('templates/feedback-new-unit.html', {
      scope: $scope
  }).then(function(pop){
    $scope.popover=pop;
  });

  $scope.$on('$destroy', function() {
    if( $scope.popover ){
      $scope.popover.remove();
    }
  });

  $scope.$modalCancel = function () {
    if( $scope.popover ){
      $scope.popover.hide();
    }
  };

  $scope.$modalOk = function (f){
    syncableDatabase.executeSql(
      "insert into feedback2 (date,name,email,feedback) values (?,?,?,?)",
      [
        new Date().getTime(),
        f.cname.$viewValue,
        f.cemail.$viewValue,
        'New region : ' + f.cregion.$viewValue + ' - ' + f.cfeedback.$viewValue
      ]
    )
    .then(function(){
      $ionicPopup.alert({
        title: 'New region request sent',
        template: 'We will be in touch.',
        cssClass: 'feedback ok',
        okType  : 'button-balanced'
      });
    })
    .catch(function(e){
      console.error('failed to save region request '+e.message);
      $ionicPopup.alert({
        title: 'Error sending request' ,
        template: 'Please contact us via the app. store instead.',
        cssClass: 'feedback error',
        okType  : 'button-balanced'
      });
    })
    .finally(function(){
      if( $scope.popover ){
        $scope.popover.remove();
      }
    });
  }

  $scope.showRegionRequestForm=function(){
    $scope.popover.show();
  }
})

;
