"use strict";
angular.module('profile-dialog', [])
.factory('profileDialog', ["$rootScope", "$ionicModal","$ionicPopup","syncableDatabase",'registerService',
function ($rootScope,$ionicModal,$ionicPopup,syncableDatabase,registerService) {
var defaults = {
  scope: null, // must implement same funcs we save to scope below
};

return function Dialog(evt/*optional*/, options, passedInLocals) {

  options = angular.extend({}, defaults, options); //options defined in constructor

  var scope = options.scope || $rootScope.$new();

  scope.jobs=[
    'Nurse',
    'Nurse specialist/practitioner',
    'FY 1 / FY 2',
    'ST medical',
    'ST surgical',
    'GP specialist trainee',
    'CMT medical',
    'CMT surgery',
    'Clinical fellow',
    'Staff grade / associate specialist',
    'Consultant',
    'Other'
  ];

  scope.hospitals=[
    'Aintree University Hospital',
    'Arrowe Park Hospital',
    'Blackpool Victoria',
    'Burnley General Hospital',
    'Chorley and South Ribble District General Hospital',
    'Christie',
    'Clatterbridge Hospital',
    'Countess of Chester Hospital',
    'Fairfield General Hospital',
    'Halton General Hospital',
    'Liverpool Heart & Chest Hospital',
    'Liverpool Women’s Hospital',
    'Macclesfield Hospital',
    'Manchester Royal Infirmary',
    'Mersey Care',
    'Mid Cheshire Hospitals',
    'Morecombe Bay',
    'Nobles Hospital, Isle of Man',
    'North Manchester General Hospital',
    'Ormskirk District General Hospital',
    'Pennine Acute',
    'Rochdale Infirmary',
    'Royal Blackburn Hospital',
    'Royal Bolton',
    'Royal Liverpool University Hospital Broadgreen Hospital',
    'Royal Oldham Hospital',
    'Royal Preston Hospital',
    'Salford Royal',
    'St Helens Hospital',
    'Southport District General Hospital',
    'Stepping Hill',
    'Tameside General',
    'The Royal Albert Edward Infirmary',
    'The Walton Centre',
    'Trafford General',
    'Warrington General Hospital',
    'Whiston Hospital',
    'Wythenshawe',
    'Other'
  ];

  scope.roleIsNotInJobs=function(form){
    for (var i = 0; i < scope.jobs.length; i++) {
      if( scope.jobs[i] == form.crole.$modelValue ){
        return false;
      }
    };
    return true;
  }

	scope.$on('$destroy', function() {
    if( scope.popover ){
      scope.popover.remove();
    }
  });

  scope.$modalCancel = function () {
    if( scope.popover ){
      scope.popover.remove();
    }
  };

  scope.$modalOk = function (form){
    // form.profile will only have properties if valid
    if( form.cemail.$valid ){
      registerService.register(
          form.cname.$modelValue,
          form.cemail.$modelValue,
          form.crole.$modelValue,
          form.croleOther.$modelValue,
          form.chospital.$modelValue,
          form.chospitalOther.$modelValue );
    }
  };
  scope.$on('event:registerFirstTime', function(e, rejection) {
    $ionicPopup.alert({
      title: 'Email sent',
      template: 'Thank you. Please check your email to complete the validation process.',
      cssClass: 'registerFirstTime',
      okType: 'button-balanced'
    });
  });
  scope.$on('event:registerChanged', function(e, rejection) {
    scope.$modalCancel();
  });

  $ionicModal.fromTemplateUrl('templates/profile.html', {
      scope: scope
  }).then(function(pop){
    scope.popover=pop;

    if( registerService.registered() ){
      var reg=registerService.get();
      scope.email=reg.email;
      scope.name           = reg.name != 'undefined'?reg.name:'';
      scope.role           = reg.role != 'undefined'?reg.role:'';
      scope.roleOther      = reg.roleOther !='undefined'?reg.roleOther:'';
      scope.hospital       = reg.hospital  !='undefined'?reg.hospital:'';
      scope.hospitalOther  = reg.hospitalOther  !='undefined'?reg.hospitalOther:'';
    }

    scope.popover.show();
  });
}
}]);