"use strict";
angular.module("register-service",[])
.factory('registerService',["$rootScope",'$ionicModal','syncableDatabase',
function($rootScope,$ionicModal,syncableDatabase){

  function RegisterService(){};

  var reg=true;         //Change this to false to be unregistered by default (beware flicker on main menu)
  var loadedProfile={};

  RegisterService._updateRegistered=function(){
  	syncableDatabase.db().transaction(function(tx) {
  		tx.executeSql("select name,email,role,roleOther,hospital,hospitalOther from reg order by date desc",null,function (tx,results){
            if( results.rows.length != 0 ){
            	console.debug('registerService setup '+results.rows.item(0).email+' registered '+results.rows.length+' times');
            }else{
            	console.debug('registerService setup not registered');
            }

            if( results.rows.length > 0 ){
              reg=true;

              loadedProfile={
                 name:results.rows.item(0).name,
                 email:results.rows.item(0).email,
                 role:results.rows.item(0).role,
                 roleOther:results.rows.item(0).roleOther,
                 hospital:results.rows.item(0).hospital,
                 hospitalOther:results.rows.item(0).hospitalOther
              };

              $rootScope.$broadcast('event:registerChanged');
            }else{
              reg=false; //Change this to false to require registration
              $rootScope.$broadcast('event:registerChanged');
            }
        })
  	});
};

  RegisterService.registered = function(){
    return reg;
  };

  RegisterService.get = function(){
    return loadedProfile;
  };

  RegisterService.register = function (name,email,role,roleOther,hospital,hospitalOther){
    syncableDatabase.db().transaction(function(tx) {
      tx.executeSql("select date from reg",null,function(tx,r){
        if( r.rows.length == 0 ){
          tx.executeSql("insert into reg (date,name,email,role,roleOther,hospital,hospitalOther) values (?,?,?,?,?,?,?)",
            [new Date().getTime(),name,email,role,roleOther,hospital,hospitalOther],
            function(tx,r){
              console.debug('registerService register registered');
              reg=true;
              loadedProfile={
                 name:name,
                 email:email?email:'',
                 role:role?role:'',
                 roleOther:roleOther?roleOther:'',
                 hospital:hospital?hospital:'',
                 hospitalOther:hospitalOther?hospitalOther:''
              };
              $rootScope.$broadcast('event:registerChanged');
              $rootScope.$broadcast('event:registerFirstTime');
            },
            function(tx,e){console.error('registerService register INSERT INTO reg failed'+e.message)}
          );
        }else{
          tx.executeSql("update reg set date=?,name=?,email=?,role=?,roleOther=?,hospital=?,hospitalOther=?",
            [new Date().getTime(),name,email,role,roleOther,hospital,hospitalOther],
            function(tx,r){
              console.debug('registerService register registered');
              reg=true;
              loadedProfile={
                 name:name,
                 email:email?email:'',
                 role:role?role:'',
                 roleOther:roleOther?roleOther:'',
                 hospital:hospital?hospital:'',
                 hospitalOther:hospitalOther?hospitalOther:''
              };
              $rootScope.$broadcast('event:registerChanged');
            },
            function(tx,e){console.error('registerService register UPDATE reg failed'+e.message)}
          );
        }
      });
    },
    function(e){ console.error('failed to save');console.dir(e); },
    function(){ syncableDatabase.sync(); }
    );
  }

  RegisterService._updateRegistered();

return RegisterService;

}

]);