"use strict";
angular.module('test-preferences', [])
.factory('testPrefDialog', ["$rootScope","$ionicPopup","syncableDatabase",
function($rootScope,$ionicPopup,syncableDatabase) {

  var defaults = {
    scope: null, // must implement same funcs we save to scope below
  };

return function Dialog(evt/*optional*/, options, passedInLocals) {

  options = angular.extend({}, defaults, options); //options defined in constructor
  var scope = options.scope || $rootScope.$new();

  scope.data = {};
  scope.data.testPref = false;

  syncableDatabase.executeSql("select * from preferences where name = 'do_not_test_popup'")
  .then(function(res) {

    if (res.rows.length == 0) {
      var confirmPopup = $ionicPopup.show({
        title: 'Switching modes',
        scope      : scope,
        cssClass   : 'testPref',
        templateUrl:'templates/testPreferences.html',
        buttons    : [
          {
            text: 'Close',
            type: 'button-balanced',
            onTap: function(e) {
                return scope.data.testPref;
            }
          }
        ]
      });

      confirmPopup.then(function(res) {
        if (res == true) {
          //console.log('Tapped!', res);
          syncableDatabase.executeSql("INSERT INTO preferences (name,value) values ('do_not_test_popup', 'true')");
        };
      });

    };
  }

  );  
}



}]);