"use strict";
angular.module('test-ask.service', [])
.factory('testService', function ($q,$document,$rootScope,$ionicPopover,syncableDatabase) {

    var self = this;
    var debug = 'not run';
    var _preferenceKey="isTest";

    self._hasSavedValue = false;

	return {
		debug:function(){return debug;},
		showDialog:function( evt,isATest,options ){
			var that=this;

    		var scope = options.scope || $rootScope.$new();

		    var closeFn = function () {
		        scope.popover.remove()
		     };
		    scope.$modalClose = closeFn;

    		scope.$modalOk = function (form){
		      var email=! form.isLive.$modelValue;

		        if( self._hasSavedValue ){
		          var sql='update preferences set value=? where name=?';
		        }else{
		          var sql='insert into preferences (value,name) values (?,?)';
		        }

		        syncableDatabase.executeSql(sql,[email,_preferenceKey]).then(function(){
				      var callFn = options.success || closeFn;
				      callFn.call(this,email);
				      scope.$modalClose();
				})
				.catch(function(e){
					throw e;
				});
			}

		    scope.$modalCancel = function () {
		      var callFn = options.cancel || closeFn;
		      callFn.call(this);
		      scope.$modalClose();
		    };

		    scope.$on('$destroy', function() {
		      scope.popover.remove();
		    });

		    syncableDatabase.executeSql('select value from preferences where name=?',[_preferenceKey])
			.then(function(res){
				if( res.rows.length == 1 ){
					self._hasSavedValue=true;
				}

				$ionicPopover.fromTemplateUrl('templates/popover-test.html', {
			      scope: scope,
			      focusFirstInput: true
			    }).then(function(popover){
			    	scope.popover = popover;
			    	scope.isLive = ! isATest;
			    	scope.popover.show(evt);
			    });
			}).catch(function(e){
				throw e;
			});

		},
		wasLastResultTest : function(){
			return syncableDatabase.executeSql('select value from preferences where name=?',[_preferenceKey])
			.then(function(res){
				debug='done q';
				var ret = true;

				if( res.rows.length == 1 && res.rows.item(0).value != null){
					debug = 'createTestDialog has pref '+res.rows.item(0).value;
					console.debug(debug);
					ret = (res.rows.item(0).value==1||res.rows.item(0).value=='true'?true:false);
				}

				console.debug('createTestDialog wasLastResultTest = '+ret);
				return ret;
			}).catch(function(e){
				throw e;
			});
		}

	}
});