angular.module('evCareCenterDirective', ['geo-service'])
.directive('evCareCenter', function() {
  return {
    restrict: 'E',
    scope: {
      locations: '=locations',
      latitude : '=latitude',
      longitude: '=longitude',
      postcodes: '=postcodes'
    },
    templateUrl: 'templates/evCareCenter.html',
    controller : function($scope,$element,$attrs,geoService){
    	$scope.$watch('locations',function(){
    		if(typeof $scope.locations == 'undefined'){ return ; }
	    	$scope.location=$scope.locations[ _nearestLocationId_postcode() ];
    	});
    	$scope.$watch('latitude',function(){
    		if(typeof $scope.locations == 'undefined'){ return ; }
			$scope.location=$scope.locations[ _nearestLocationId_postcode() ];
    	});
    	$scope.$watch('longitude',function(){
    		if(typeof $scope.locations == 'undefined'){ return ; }
			$scope.location=$scope.locations[ _nearestLocationId_postcode() ];
    	});
    	$scope.$watch('postcodes',function(){
    		if(typeof $scope.locations == 'undefined'){ return ; }
			$scope.location=$scope.locations[ _nearestLocationId_postcode() ];
    	});

    	$scope.selectByIndex=function(i){
    		$scope.location=$scope.locations[ i ];
    	}

    	$scope.distanceToLocation=function(loc){
    		if( typeof $scope.latitude  == 'undefined'  ||
				typeof $scope.longitude == 'undefined' ||
				typeof loc == 'undefined'){
    			return '';
    		}
    		var d=geoService.distance(
    			$scope.latitude,$scope.longitude,
    			loc.latitude,loc.longitude
    		);
    		if( d == NaN ){
    			return '';
    		}

    		return Math.round(d*0.621371192);
    	}

    	function _nearestLocationId_postcode(){
			if( typeof $scope.postcodes  !='undefined' &&
				typeof $scope.latitude  !='undefined' &&
				typeof $scope.latitude  !='undefined' &&
				typeof $scope.locations !='undefined'){
//console.info('evCareCenter : start postcode search');
				var pos=0;
				var minDistance=Number.MAX_VALUE;
				for (var i = 0; i < $scope.postcodes.length; i++) {
					var d=distance( $scope.latitude,$scope.longitude,$scope.postcodes[i].lat,$scope.postcodes[i].lon );
					if(d<minDistance){
						minDistance=d;
						pos=i;
					}
				}
console.info('evCareCenter : done postcode search. Match '+pos+' @ '+minDistance+'km');
console.dir($scope.postcodes[pos]);

				$scope.locationDebug = 'Nearest postcode '+$scope.postcodes[pos].postcode+' '+minDistance+'km';
				$scope.distance = minDistance ;

				for (var i = 0; i < $scope.locations.length; i++) {
					if( $scope.locations[i].id == $scope.postcodes[pos].hospitalCode ){
						console.log('selecting hospital @'+i);
						return i;
					}
				}

console.debug('evCareCenter : selecting first location');
				return 0;

			}else{
console.debug('evCareCenter ! selecting first location');
				return 0;
			}
		}
    },
    link: function(scope, element, attrs) {
    	element.find('select').on('change',function(e){
    		//doesnt work as outside angular here : scope.selectByIndex( e.target.selectedIndex );

    		scope.$apply(function(){
    			scope.selectByIndex( e.target.selectedIndex );
    		});
    	})
    }
  };
});

